#ifndef NAG_RWRAPPER_UTILS_H
#define NAG_RWRAPPER_UTILS_H

#include <R.h>
#include <Rinternals.h>

/* The FEXAMPLE preprocessor variable just controls whether we are 
   compiling a Fortran example or a C example. If it is defined then
   it is assumed that we are compiling a Fortran example
*/
#ifdef FEXAMPLE
#include "nag_fortran_routines.h"
#else
#include <nag.h>
#include <nage04.h>
#define NAG_fortran_integer int
#endif

extern void nag_convert_p2i(SEXP p, NAG_fortran_integer *v);
extern void nag_convert_i2p(NAG_fortran_integer *v, SEXP *p);
extern SEXP nag_getListElement(SEXP list, const char *str);
 
extern SEXP nag_d2r(int n, double x[]);
extern SEXP nag_2d2r(int n1, double x1[], int n2, double x2[]);
extern SEXP nag_i2r(int n, Integer x[]);
extern SEXP nag_fi2r(int n, NAG_fortran_integer x[]);
extern SEXP nag_l2l(int n, Nag_Boolean x[]);
extern SEXP nag_md2r(int cmajor, int nrow, int ncol, double m[]);

extern int nag_extractDoubleVector(int n, SEXP v, double cv[]);
extern int nag_extractIntegerVector(int n, SEXP v, Integer cv[]);
extern int nag_isNumericVector(int n, SEXP v);
extern int nag_extractDoubleMatrix(int cmajor, int nrow, int ncol, SEXP m, double cm[]);
extern int nag_isNumericMatrix(int nrow, int ncol, SEXP m);

extern SEXP lang5(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4);
extern SEXP lang6(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5);
extern SEXP lang7(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6);
extern SEXP lang8(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7);
extern SEXP list5(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4);
extern SEXP list6(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5);
extern SEXP list7(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6);

#endif
